#!/usr/bin/perl
#set the line above this to your perl path. Usually fine as is
# or /usr/local/bin/perl  /sbin/perl
# make certain that the first line stays the first line!
##################################################################
#  (C)1998 Bignosebird.com   cardcgi v1.2
#  This software is FREEWARE! Do with it as you wish. It is yours
#  to share and enjoy. Modify it, improve it, and have fun with it!
#  It is distributed strictly as a learning aid and bignosebird.com
#  disclaims all warranties- including but not limited to:
#  fitness for a particular purpose, merchantability, loss of
#  business, harm to your system, etc... ALWAYS BACK UP YOUR
#  SYSTEM BEFORE INSTALLING ANY SCRIPT OR PROGRAM FROM ANY
#  SOURCE!

$|=1;

#### PROGRAM CONFIGURATION SECTION ############################
#
# Modify each item below to meet your needs.
#
# DAYS: number of days to keep cards before purging
# MAIL_PROGRAM should be the path to your sendmail program
# BASEDIR is the unix directory that your greeting cards will
#   be stored in.
# BASEURL is the URL (http address) of the directory your cards
#   will be stored in.
# SITEURL is the home page URL for your site.
# SITENAME is the Name of your site, ie Title
# EXT is the ending name for your card files. NEVER, EVER USE shtml!!
# PROGNAME is the URL of THIS script.
# MY_EMAIL is YOUR e-mail address! BE SURE to put that backslash
#    BEFORE THE \@ sign
# okaydomains are (if specified, the ONLY domains that the script
#    can be run from. If left empty, anyone could run your script,
#    but they wouldn't see any graphics!!! If your site answers to
#    both www.domain.com and domain.com, then use both!
#
#@okaydomains=("http://bignosebird.com", "http://www.bignosebird.com");
$DAYS=11;
$MAIL_PROGRAM="/usr/sbin/sendmail -t";
$BASEDIR="/home/www/web22/html/cgi/grafik/card";
$BASEURL="http://www.jeej.de/cgi/grafik/card";
$SITEURL="http://www.jeej.de";
$SITENAME="jeej.de";
$EXT=".html";
$PROGNAME="http://jeej.de/cgi-bin/grafik/card/card.cgi";
$MY_EMAIL="webmaster\@jeej.de";
$VALID_DOMAIN="http://www.jeej.de";
###############################################################
###############################################################
#
# Now go thru the program looking for the string "BNB SAYS!"
# to locate other changes you should make, such as wording of
# the notification e-mail and "plug" for the site.
#
# to keep things simple, the field names are hard coded in.
# you can of course modify what you wish.
###############################################################


   &valid_page;
   &test_sendmail;
   &test_basedir;

#This part of the program splits up our data and gets it
#ready for formatting.
  $i=0;
  read(STDIN,$temp,$ENV{'CONTENT_LENGTH'});
  @pairs=split(/&/,$temp);
  foreach $item(@pairs)
   {
    ($key,$content)=split(/=/,$item,2);
    $content=~tr/+/ /;
    $content=~s/%(..)/pack("c",hex($1))/ge;
    $content =~ s/<!--(.|\n)*-->//g;
    $fields{$key}=$content;
    $i++;
    $item{$i}=$key;
    $response{$i}=$content;
   }
if ($fields{'background'} ne "")
 { $BODYTAG="<BODY BACKGROUND=\"$BASEURL/$fields{'background'}\">";}
  else { $BODYTAG="<BODY BGCOLOR=\"#000000\" text=\"#ffffff\" link=#ccff88 vlink=ccff88 alink=#ccff88>"; }

if ($fields{'recip_email'} eq "")
  {
    &no_email;
    exit;
  }
if (&valid_address == 0)
 {
   &bad_email;
   exit;
 }

# BNB SAYS! REMOVE THIS BLOCK OF CODE IF YOU DO NOT CARE ABOUT THE
# SENDER'S EMAIL ADDRESS.
if ($fields{'sender_email'} eq "")
  {
    &no_email;
    exit;
  }
#END OF THE ABOVE BLOCK OF CODE

if ($fields{'action_code'} eq "NEW")
  {
     &do_preview;
  }
if ($fields{'action_code'} eq "SENDCARD")
  {
     &get_file_name;
     &create_file;
     &send_mail;
     &thank_you;
     if ($DAYS > 0)
      {&card_expire;}
  }



#Set up our HTML Preview Form
sub do_preview
{
$fields{'the_message'} =~ s/\r?\n/<br>/g; 
print <<__STOP_OF_PREVIEW__;
Content-type: text/html


<HTML>
<SCRIPT LANGUAGE="JavaScript">
<!--
if(navigator.userAgent.indexOf("MSIE") != -1)
document.writeln ('');
else
document.writeln ('<EMBED SRC="$BASEURL/$fields{'midifile'}" AUTOSTART="true" HIDDEN="true" VOLUME="80%">');
//-->
</SCRIPT>
<BGSOUND SRC="$BASEURL/$fields{'midifile'}">

$BODYTAG
<CENTER>

<TABLE WIDTH=500 cellspacing=0 cellpadding=2 BGCOLOR=$fields{'back_color'} BORDER=1>
 <TR>
 <TD>
<TABLE WIDTH=500 BORDER=0 cellspacing=0 cellpadding=2 BGCOLOR=$fields{'back_color'}>
 <TR>
 <TD>
<TABLE cellspacing=0 cellpadding=2 BORDER=1>
    <TR>
      <TD ALIGN=CENTER VALIGN=CENTER>
       <IMG SRC=$BASEURL/$fields{'pic_select'} HEIGHT=250 WIDTH=175 BORDER=0><P>
      </TD>
    </TR>
  </TABLE>
 </TD>
 <TD WIDTH=380 VALIGN=TOP >
   <CENTER>
   <FONT SIZE=+2 COLOR=$fields{'text_color'}
     FACE=ARIAL><B>$fields{'the_title'}</B></FONT>
   <HR noshade>
   <TABLE WIDTH=355>
    <TR>
     <TD><FONT FACE=ARIAL COLOR=$fields{'text_color'}>
         $fields{'the_message'}

      <P ALIGN=CENTER>
      <I>$fields{'sig_line'}
      </I>
      </P>
      </FONT>
      </TD>
    </TR>
   </TABLE>
   </CENTER>
 </TD>
 </TR>
</TABLE>
</TD>
</TR>
</TABLE>
<P>
<TABLE WIDTH=500>
  <TR>
  <TD align=center>
  <FONT FACE="ARIAL">
  Diese Karte wurde von <I><A HREF=mailto:$fields{'sender_email'}>$fields{'sender_name'}</A></I> fr $fields{'recip_name'} gemacht.
  <BR>Willst Du $fields{'sender_name'} auch eine Karte basteln, klicke auf folgenden Link:<BR>
  <A HREF=$BASEURL/card.html>$SITEURL</A>
  </FONT>
  <CENTER>
<FORM METHOD="POST" ACTION="$PROGNAME">
<INPUT TYPE="HIDDEN" NAME="action_code" VALUE="SENDCARD">
<INPUT TYPE="HIDDEN" VALUE="$fields{'pic_select'}" NAME="pic_select">
<INPUT TYPE="HIDDEN" VALUE="$fields{'sender_name'}" NAME="sender_name">
<INPUT TYPE="HIDDEN" VALUE="$fields{'sender_email'}" NAME="sender_email">
<INPUT TYPE="HIDDEN" VALUE="$fields{'recip_name'}" NAME="recip_name">
<INPUT TYPE="HIDDEN" VALUE="$fields{'recip_email'}" NAME="recip_email">
<INPUT TYPE="HIDDEN" VALUE="$fields{'text_color'}" NAME="text_color">
<INPUT TYPE="HIDDEN" VALUE="$fields{'back_color'}" NAME="back_color">
<INPUT TYPE="HIDDEN" VALUE="$fields{'the_title'}" NAME="the_title">
<INPUT TYPE="HIDDEN" VALUE="$fields{'the_message'}" NAME="the_message">
<INPUT TYPE="HIDDEN" VALUE="$fields{'sig_line'}" NAME="sig_line">
<INPUT TYPE="HIDDEN" VALUE="$fields{'midifile'}" NAME="midifile">
<INPUT TYPE="HIDDEN" VALUE="$fields{'background'}" NAME="background">
<INPUT TYPE="HIDDEN" VALUE="$ENV{'HTTP_REFERER'}" NAME="parent">
<INPUT TYPE="submit" VALUE="Karte Erstellen">
</FORM>
</CENTER>
 <FONT FACE="ARIAL">
 <B>Um die Karte zu erstellen, klicke auf "Karte Erstellen".
 <BR>Um sie ndern, klicke auf den "zurck"-Button des Browsers.
 </B>
 </FONT>
  </TD>
  </TR>
</TABLE>
</CENTER>
</BODY>
</HTML>

__STOP_OF_PREVIEW__
}

#Get the file name and increment the counter
#create the file name based on both the month/day
#and counter value. Makes for easy cleanup of holding
#directory!
sub get_file_name
{
   $proc=$$;
   $newnum=time;
   $newnum=substr($newnum,4,5);

   $date=localtime(time);
   ($day, $month, $num, $time, $year) = split(/\s+/,$date);
   $month=~tr/A-Z/a-z/;
   $PREF = "$month$num-";

$FILE_NAME="$BASEDIR/$PREF$newnum$proc$EXT";
$URL_NAME="$BASEURL/$PREF$newnum$proc$EXT";
}


#Write out our HTML FILE
sub create_file
{
   open(OUTFILE,">$FILE_NAME") ;
print OUTFILE <<__STOP_OF_CRFILE__;

<HTML>
<SCRIPT LANGUAGE="JavaScript">
<!--
if(navigator.userAgent.indexOf("MSIE") != -1)
document.writeln ('');
else
document.writeln ('<EMBED SRC="$BASEURL/$fields{'midifile'}" AUTOSTART="true" HIDDEN="true" VOLUME="80%">');
//-->
</SCRIPT>
<BGSOUND SRC="$BASEURL/$fields{'midifile'}">
$BODYTAG
<CENTER>
<TABLE WIDTH=500 cellspacing=0 cellpadding=2 BGCOLOR=$fields{'back_color'} BORDER=1>
 <TR>
 <TD>
<TABLE WIDTH=500 BORDER=0 cellspacing=0 cellpadding=2 BGCOLOR=$fields{'back_color'}>
 <TR>
 <TD>
<TABLE cellspacing=0 cellpadding=2 BORDER=1>
    <TR>
      <TD ALIGN=CENTER VALIGN=CENTER>
       <IMG SRC=$BASEURL/$fields{'pic_select'} HEIGHT=250 WIDTH=175 BORDER=0><P>
      </TD>
    </TR>
  </TABLE>
 </TD>
 <TD WIDTH=380 VALIGN=TOP >
   <CENTER>
   <FONT SIZE=+2 COLOR=$fields{'text_color'}
     FACE=ARIAL><B>$fields{'the_title'}</B></FONT>
   <HR noshade>
   <TABLE WIDTH=355>
    <TR>
     <TD><FONT FACE=ARIAL COLOR=$fields{'text_color'}>
         $fields{'the_message'}

      <P ALIGN=CENTER>
      <I>$fields{'sig_line'}
      </I>
      </P>
      </FONT>
      </TD>
    </TR>
   </TABLE>
   </CENTER>
 </TD>
 </TR>
</TABLE>
</TD>
</TR>
</TABLE>
<P>
<TABLE WIDTH=500>
  <TR>
  <TD align=center>
  <FONT FACE="ARIAL">
  Diese Karte wurde von <I><A HREF=mailto:$fields{'sender_email'}>$fields{'sender_name'}</A></I> fr $fields{'recip_name'} gemacht.
  <BR>Willst Du $fields{'sender_name'} auch eine Karte basteln, klicke auf folgenden Link:<BR>
  <A HREF=$BASEURL/card.html>$SITEURL</A>
  </FONT>
<CENTER>
<br>
<br>
<br>
<FONT FACE="ARIAL" SIZE="-1"><B>
Card Creator Script von: <A HREF="http://bignosebird.com"/>BigNoseBird.com</A>
</B><BR>
</CENTER>
 </TD>
  </TR>
</TABLE>
</CENTER>
</BODY>
</HTML>

__STOP_OF_CRFILE__
close (OUTFILE);
}

sub thank_you
{
open (ML,">>$BASEDIR/maillog");
print ML "$fields{'recip_email'}\n";
print ML "$fields{'sender_email'}\n";
close(ML);

print <<__STOP_OF_THANKS__;
Content-type: text/html

$BODYTAG
<CENTER>

<H1><B>Danke!</B></H1>
Eine Mail mit der URL wurde an $fields{'recip_name'} geschickt.<BR>
Die URL der Karte ist:<P>
<A HREF="$URL_NAME">$URL_NAME</A>
<P>
<B><A HREF=$fields{'parent'}>Zurck zum Card Creator</A></B>
<P>

__STOP_OF_THANKS__
}


sub no_email
{
print <<__STOP_OF_NOMAIL__;
Content-type: text/html

$BODYTAG
<FONT SIZE="+1">
<B>
<H1><B>Danke!</B></H1>
Es mssen beide E-Mail Adressen angegeben werden.
<BR>Klicke auf den "zurck"-Button des Browsers und versuche es nochmal.
</B>
</FONT>
__STOP_OF_NOMAIL__
}

#BNB SAYS! Change the email address in "From:" to your e-mail
#  address. Also, modify the text below to meet your needs.
#  make certain everything is between the __STOP_OF_MAIL2__
#  markers.
sub send_mail
{
open (MAIL_RECIP, "|$MAIL_PROGRAM");
print MAIL_RECIP <<__STOP_OF_MAIL2__;
To: $fields{'recip_email'}
From: $MY_EMAIL
Subject: Eine Virtuelle Postkarte wartet auf dich!

Hi,

$fields{'sender_name'} bastelte auf $SITENAME
eine virtuelle Postkarte fr dich.

Klicke einfach auf:
   $URL_NAME

Diese Karte bleibt eine Woche erhalten!


__STOP_OF_MAIL2__
close(MAIL_RECIP);
}

sub card_expire
 {
  local(@items, $item);
  opendir(CARDDIR, "$BASEDIR");
  @items = grep(/[0-9]$EXT/,readdir(CARDDIR));
  closedir(CARDDIR);
  foreach $item (@items)
   {
    if (-M "$BASEDIR/$item" > $DAYS)
     {
      unlink("$BASEDIR/$item");
     }
   }
 }


##################################################################
sub test_sendmail
 {
  @ts=split(/ /,$MAIL_PROGRAM);
  if ( -e $ts[0] )
   {
    return;
   }
   print "Content-type: text/html\n\n";
   print "<H2>$ts[0] NOTFOUND. PLEASE CHECK YOUR SCRIPT'S MAIL_PROGRAM VARIABLE</H2>";
   exit;
 }

##################################################################
sub valid_address
 {
  $testmail = $fields{'recip_email'};
  if ($testmail =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/ ||
  $testmail !~ /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/)
   {
     return 0;
   }
   else
    {
      return 1;
    }
}


sub bad_email
{
print <<__STOP_OF_BADMAIL__;
Content-type: text/html

<FONT SIZE="+1">
<B>
SORRY! Your request could not be processed because of an improper
recipient's e-mail address. Please use your back button to return
to the card screen and try again!
</B>
</FONT>
__STOP_OF_BADMAIL__
}

sub test_basedir
{
  if (not -w $BASEDIR)
   {
print <<__STOP_OF_BADBASE__;
Content-type: text/html

<FONT SIZE="+1">
<B>
Das Script kann in folgendes Verzeichniss schreiben, oder findet es nicht:<BR>
$BASEDIR
Checke das nochmal und setze die Benutzerrechte auf 777
</B>
</FONT>
__STOP_OF_BADBASE__
exit;
   }
}

##################################################################
sub valid_page
 {

 if (@okaydomains == 0)
   {return;}

$DOMAIN_OK=0;
  $DOMAIN_OK=0;
  $RF=$ENV{'HTTP_REFERER'};
  $RF=~tr/A-Z/a-z/;
  foreach $ts (@okaydomains)
   {
     if ($RF =~ /$ts/)
      {
        $DOMAIN_OK=1;
      }
   }
   if ( $DOMAIN_OK == 0)
     {
      print "Content-type: text/html\n\n Sorry, cant run it from here....";
      exit;
     }

}